Subject: Template Analyzer produces wrong results

Description

Running through the Template Analyzer | noticed some weird and unexpected results.

Selecting an included template on the top does show Constants plus Setup from the corresponding template.

The Content of the Constants is fine and does match the Template.

The Content of the Setups is borked. It seems to contain the content of the previous template. Seems like some index is used wrong

and introduces a -1 offset.

As | have just noticed it on one installation | am not sure wether it needs something else to trigger this.

Related issues:

related to Core - Bug # 52852: Template Analyzer does not show Includes Closed
blocked by Core - Bug # 43540: TS is fetched from cache incorrectly sometimes Resolved
precedes Core - Bug # 54897: Wrong lineNumbers and templateNames in TypoScrip... Resolved

2013-10-15
2012-12-03
2014-01-10

Associated revisions

Revision 5fe23203 - 2014-01-14 14:08 - Peter Niederlag

[BUGFIX] Add defaultTypoScript to hierachylInfo

Fixes a problem with the TemplateAnalyzer introduced by #43540

- Always add both defaultTypoScript_setup and defaultTypoScript_constants.
- Add information for defaultTypoScript into hierarchyInfo.

Change-Id: I15ad5f268eb167d6c8f027e1891409d9ead64539
Resolves: #53352

Releases: 6.2, 6.1, 4.7

Reviewed-on: https://review.typo3.0rg/26738

Reviewed-by: Markus Klein
Reviewed-by: Michiel Roos
Tested-by: Michiel Roos
Reviewed-by: Stefan Neufeind
Reviewed-by: Benjamin Mack
Tested-by: Benjamin Mack

Revision f68832a2 - 2014-01-14 14:26 - Peter Niederlag
[BUGFIX] Add defaultTypoScript to hierachylnfo

Fixes a problem with the TemplateAnalyzer introduced by #43540

- Always add both defaultTypoScript_setup and defaultTypoScript_constants.
- Add information for defaultTypoScript into hierarchyInfo.

Resolves: #53352

Releases: 6.2, 6.1, 6.0,4.7, 4.5

Change-Id: 15d76bd092b1a8f509c90849774e916¢c7{d83b438
Reviewed-on: https://review.typo3.org/26804

Reviewed-by: Benjamin Mack

Tested-by: Benjamin Mack

Revision df52d4a8 - 2014-01-14 14:26 - Peter Niederlag

[BUGFIX] Add defaultTypoScript to hierachylnfo

[BUGFIX] Add defaultTypoScript to hierachylnfo

Fixes a problem with the TemplateAnalyzer introduced by #43540

- Always add both defaultTypoScript_setup and defaultTypoScript_constants.
- Add information for defaultTypoScript into hierarchyInfo.

Resolves: #53352

Releases: 6.2, 6.1, 6.0, 4.7, 4.5

Change-Id: 197d8237a9d665188eb9f5db06d47d8403ba5aca5
Reviewed-on: https://review.typo3.org/26805

Reviewed-by: Benjamin Mack
Tested-by: Benjamin Mack

History

#1 - 2013-11-08 19:05 - Christian Kuhn

Seen that too, tried to dig into it. Seems to be a weird behavior in the parser itself.

#2 - 2013-11-12 18:13 - Peter Niederlag

[UPDATE: this is irrelevant for the bug! ~pn]
don't know if that is related but | just noticed that single line of comment followed by multiline comment the multiline comment is not recognized as
comment and evaluated as typoscript

// fix/change innerWrap
/*
tt_content.stdWrap.innerWrap.cObject.default.20.10 >
tt_content.stdWrap.innerWrap.cObject.default.20.10 = COA
tt_content.stdWrap.innerWrap.cObject.default.20.10 {

10 = CASE

10 {
default.field = CType

key = CType

stdWrap.noTrimWrap = || |
1

*/

also the code is in multiline comment it will be "executed"

#3 - 2013-11-12 21:57 - Christian Kuhn

This is getting more weird.

On one system i can reproduce this by loading felogin, if unloading, the issue is gone, on another system that does not work.

At the moment | either suspect something with packages and states or with Peters idea of a broken comment parser.

#4 - 2013-12-19 07:50 - Torben Hansen

| can also reproduce this on TYPOS3 4.7. When | click on an extension template in the template analyzer, the constants seem to show correctly, but the

setup is wrong and always shows the TS setup from the previous element.

#5 - 2013-12-19 08:47 - Torben Hansen

The bug came with #43540. In this change $this->addDefaultTypoScript() has been added at the end of to the function runThroughTemplates().

See

http://forge.typo3.org/projects/typo3cms-core/repository/diff/t3lib/class.t3lib_tstemplate.php?rev={8f155e51465551681e5e14c5f16f8a7e719d9d4&#38;
ype=sbs in line 419

When | remove $this->addDefaultTypoScript() in line 419, everything seems to work fine again. IMHO this line has been added by mistake and should

be removed again, since the default TS is added later by generateConfig().

This bug affects all supported TYPOS3 versions.

#6 - 2013-12-19 15:00 - Peter Niederlag

just FYI, I am still digging into it and probably come up with a patch today

#7 - 2013-12-30 21:22 - Matthias Siincksen
I'm seeing it in 4.7.17 where | believe the bugfix for #43540 is included. Is it a regression bug with the TS-caching fix breaking the template analyzer ?
In the original report of #43540 it is said that the Install tool may set $§GLOBALS['TYPO3_CONF_VARS'|['FE"|['defaultTypoScript_setup']. But it appears

much more being dynamically filled by class.t3lib_extmgm.php:addTypoScript() through some installed extensions (i.e. fe_login), so it's no option trying
to clear the variable.
#8 - 2014-01-09 21:25 - Ernesto Baschny
- Status changed from New to Accepted

- Target version set to next-patchlevel

- TYPOS3 Version changed from 6.2 to 4.7
- Is Regression changed from No to Yes

This is indeed a regression introduced by #43540 (included in 4.7, 6.0, 6.1 and master). So this has to be fixed in master and the fix backported to 4.7.

Note that the performance enhancement hasn't been merged in 4.5 yet.

#9 - 2014-01-10 09:27 - Peter Niederlag

| have spent days on this matter already. The basic problem is that the count of the arrays with typoscript and template-information don't match any
longer due to the patch of #43540.

$GLOBALS]['tmpl']->hierarchylInfo // array with template information
$GLOBALS['tmpl']->constants // array with constants per template
$GLOBALSJ['tmpl']->config // array with setup per template

1. The BE TypoScript Tools always expect a corresponding pair of setup[config]/constants. If the content of these are checked for empty string
individually then it happens that information doesn't match. Solution would be to always add both when one of it is not empty.
2. As we now prepend entries to ->constants and ->config in addDefaultTypoScript() we should also prepend proper information to ->hierarchylInfo

(adding the default TypoScript to the templates shown in the template analyzer) or ignore the first template in template tools.

| am also working on fixing some anoying problems with wrong line-numbers that's why it is taking rather long time in these dark parts of the code.

The patch/patchs will be ready soon.

#10 - 2014-01-10 14:27 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/26738

#11 - 2014-01-10 14:29 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26738

#12 - 2014-01-10 14:48 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26738

#13 - 2014-01-10 14:54 - Gerrit Code Review
Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/26738

#14 - 2014-01-14 14:11 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26804

#15 - 2014-01-14 14:16 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-1 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26804

#16 - 2014-01-14 14:17 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-0 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/26805

#17 - 2014-01-14 14:21 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-7 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26806

#18 - 2014-01-14 14:30 - Anonymous
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:df52d4a8caldd193e04fc7c7ea751dd3d7bf7fb5.
